# 4.1.4

Release date: `2019-08-02`

## Core

- [NXDRIVE-695](https://jira.nuxeo.com/browse/NXDRIVE-695): File is not deleted on the server when the parent folder is renamed, while offline
- [NXDRIVE-980](https://jira.nuxeo.com/browse/NXDRIVE-980): Renaming files server-side to solve duplicate issues results in wrong local files count
- [NXDRIVE-1219](https://jira.nuxeo.com/browse/NXDRIVE-1219): Use a dedicated temporary folder for downloads
- [NXDRIVE-1392](https://jira.nuxeo.com/browse/NXDRIVE-1392): Processor loops when a file is not found and locally created
- [NXDRIVE-1604](https://jira.nuxeo.com/browse/NXDRIVE-1604): Enable to pause and resume uploads
- [NXDRIVE-1627](https://jira.nuxeo.com/browse/NXDRIVE-1627): Pause all transfers when suspending the synchronization
- [NXDRIVE-1629](https://jira.nuxeo.com/browse/NXDRIVE-1629): Enable to pause and resume downloads
- [NXDRIVE-1642](https://jira.nuxeo.com/browse/NXDRIVE-1642): [Windows] Fix renaming
- [NXDRIVE-1660](https://jira.nuxeo.com/browse/NXDRIVE-1660): Cannot rename root at the top level folder
- [NXDRIVE-1669](https://jira.nuxeo.com/browse/NXDRIVE-1669): Force write of file to disk
- [NXDRIVE-1671](https://jira.nuxeo.com/browse/NXDRIVE-1671): Only cleanup well-formed folders in DirectEdit directory
- [NXDRIVE-1691](https://jira.nuxeo.com/browse/NXDRIVE-1691): Make DAO attributes public
- [NXDRIVE-1692](https://jira.nuxeo.com/browse/NXDRIVE-1692): Make Engine's QueueManager public
- [NXDRIVE-1695](https://jira.nuxeo.com/browse/NXDRIVE-1695): Fix conflict resolving regression
- [NXDRIVE-1700](https://jira.nuxeo.com/browse/NXDRIVE-1700): Review `get_syncing_count()`
- [NXDRIVE-1707](https://jira.nuxeo.com/browse/NXDRIVE-1707): Set the UTF-8 encoding while opening/reading/writing text files
- [NXDRIVE-1717](https://jira.nuxeo.com/browse/NXDRIVE-1717): Use `sizeof_fmt()` to have proper speed metrics
- [NXDRIVE-1721](https://jira.nuxeo.com/browse/NXDRIVE-1721): Fix `get_timestamp_from_date()` signature
- [NXDRIVE-1722](https://jira.nuxeo.com/browse/NXDRIVE-1722): Correctly handle Unauthorized and Forbidden statuses
- [NXDRIVE-1723](https://jira.nuxeo.com/browse/NXDRIVE-1723): When selecting a local folder on auth, another folder is selected
- [NXDRIVE-1727](https://jira.nuxeo.com/browse/NXDRIVE-1727): Check for local folder rights and fail gracefully on permission error
- [NXDRIVE-1728](https://jira.nuxeo.com/browse/NXDRIVE-1728): Lower logging level of "Cannot find parent pair of postponed remote descendant, ..."
- [NXDRIVE-1729](https://jira.nuxeo.com/browse/NXDRIVE-1729): [macOS] Use EAFP to catch `FileNotFoundError` in `send_content_sync_status()`
- [NXDRIVE-1732](https://jira.nuxeo.com/browse/NXDRIVE-1732): Better handling of the Direct Edit protocol
- [NXDRIVE-1733](https://jira.nuxeo.com/browse/NXDRIVE-1733): Fix missing `select` argument in `open_local_file()`
- [NXDRIVE-1734](https://jira.nuxeo.com/browse/NXDRIVE-1734): Ignore decoding issues when retrieving the path stored in xattrs
- [NXDRIVE-1735](https://jira.nuxeo.com/browse/NXDRIVE-1735): Make Manager's engines public
- [NXDRIVE-1736](https://jira.nuxeo.com/browse/NXDRIVE-1736): Filter out the `WinError` 123 (about long file names too long)
- [NXDRIVE-1740](https://jira.nuxeo.com/browse/NXDRIVE-1740): Remove unpopular `Engine.get_errors()`
- [NXDRIVE-1744](https://jira.nuxeo.com/browse/NXDRIVE-1744): Always use the full exception string when increasing an error
- [NXDRIVE-1746](https://jira.nuxeo.com/browse/NXDRIVE-1746): Fix the `--ssl-no-verify` option from the CLI that is always set to False
- [NXDRIVE-1752](https://jira.nuxeo.com/browse/NXDRIVE-1752): Fix account removal when the server is not responding
- [NXDRIVE-1753](https://jira.nuxeo.com/browse/NXDRIVE-1753): Improve uploads robustness
- [NXDRIVE-1754](https://jira.nuxeo.com/browse/NXDRIVE-1754): [macOS] `locale.getdefaultlocale()` fails with default language set to English
- [NXDRIVE-1765](https://jira.nuxeo.com/browse/NXDRIVE-1765): Skip inexistant files in DirectEdit's lock queue
- [NXDRIVE-1766](https://jira.nuxeo.com/browse/NXDRIVE-1766): Fix extensions local server to listen on localhost
- [NXDRIVE-1773](https://jira.nuxeo.com/browse/NXDRIVE-1773): Check the parent exists before trying to retrieve its details
- [NXDRIVE-1774](https://jira.nuxeo.com/browse/NXDRIVE-1774): Filter out `urllib3` logging about "Certificate did not match..."
- [NXDRIVE-1775](https://jira.nuxeo.com/browse/NXDRIVE-1775): Bypass `PermissionError` raised from `Path.resolve()`
- [NXDRIVE-1776](https://jira.nuxeo.com/browse/NXDRIVE-1776): Handle incorrect chunked encoding in Direct Edit's upload queue
- [NXDRIVE-1777](https://jira.nuxeo.com/browse/NXDRIVE-1777): Force re-download if a local file does not exist anymore but it is still referenced in the database
- [NXDRIVE-1779](https://jira.nuxeo.com/browse/NXDRIVE-1779): Ensure the tmp folder is on the same partition than the sync folder
- [NXDRIVE-1780](https://jira.nuxeo.com/browse/NXDRIVE-1780): Fix "Access online" context menu not opening the browser

## GUI

- [NXDRIVE-1558](https://jira.nuxeo.com/browse/NXDRIVE-1558): Display a progress bar when opening a file in DirectEdit
- [NXDRIVE-1673](https://jira.nuxeo.com/browse/NXDRIVE-1673): Use native dialog when Qt is unavailable (for the fatal error screen only)
- [NXDRIVE-1681](https://jira.nuxeo.com/browse/NXDRIVE-1681): Make server URL and local folder clickable in the Accounts settings
- [NXDRIVE-1683](https://jira.nuxeo.com/browse/NXDRIVE-1683): Display a notification when DirectEdit'ing an inexistant document
- [NXDRIVE-1684](https://jira.nuxeo.com/browse/NXDRIVE-1684): Display the file size in the systray
- [NXDRIVE-1685](https://jira.nuxeo.com/browse/NXDRIVE-1685): Display a progress bar when checking the file integrity
- [NXDRIVE-1688](https://jira.nuxeo.com/browse/NXDRIVE-1688): Do not display the update channel in the release notes window
- [NXDRIVE-1698](https://jira.nuxeo.com/browse/NXDRIVE-1698): Display the progress bar when resuming an upload
- [NXDRIVE-1705](https://jira.nuxeo.com/browse/NXDRIVE-1705): Add an option to remove local files when removing an account
- [NXDRIVE-1726](https://jira.nuxeo.com/browse/NXDRIVE-1726): Show Account setting at statup if there is no account
- [NXDRIVE-1751](https://jira.nuxeo.com/browse/NXDRIVE-1751): Localize the "B" abbreviation for "byte" in `sizeof_fmt()`
- [NXDRIVE-1762](https://jira.nuxeo.com/browse/NXDRIVE-1762): Display a progress bar when attaching the blob to a document
- [NXDRIVE-1781](https://jira.nuxeo.com/browse/NXDRIVE-1781): Display size details on progress of a download/upload

## Packaging / Build

- [NXDRIVE-1224](https://jira.nuxeo.com/browse/NXDRIVE-1224): Upgrade from Python 3.6.8 to 3.7.3
- [NXDRIVE-1474](https://jira.nuxeo.com/browse/NXDRIVE-1474): Generate an AppImage for GNU/Linux distribution
- [NXDRIVE-1760](https://jira.nuxeo.com/browse/NXDRIVE-1760): Remove docstrings from packages
- [NXDRIVE-1764](https://jira.nuxeo.com/browse/NXDRIVE-1764): Upgrade to PyInstaller 3.5
- [NXDRIVE-1770](https://jira.nuxeo.com/browse/NXDRIVE-1770): Upgrade from Python 3.7.3 to 3.7.4
- [NXDRIVE-1793](https://jira.nuxeo.com/browse/NXDRIVE-1793): Update pip before installing dependencies

## Tests

- [NXDRIVE-1687](https://jira.nuxeo.com/browse/NXDRIVE-1687): Improve test results visualization
- [NXDRIVE-1693](https://jira.nuxeo.com/browse/NXDRIVE-1693): Fix file paths in the coverage report
- [NXDRIVE-1694](https://jira.nuxeo.com/browse/NXDRIVE-1694): Add the SKIP envar to bypass specific actions
- [NXDRIVE-1697](https://jira.nuxeo.com/browse/NXDRIVE-1697): Add tests for the transfers pause/resume feature
- [NXDRIVE-1702](https://jira.nuxeo.com/browse/NXDRIVE-1702): Enable concurrent pipeline builds
- [NXDRIVE-1704](https://jira.nuxeo.com/browse/NXDRIVE-1704): Add the current git branch in Sentry tags
- [NXDRIVE-1769](https://jira.nuxeo.com/browse/NXDRIVE-1769): Silence logging errors when running the tests suite

## Doc

- [NXDRIVE-1745](https://jira.nuxeo.com/browse/NXDRIVE-1745): Add a diff link in changes documentation
- [NXDRIVE-1772](https://jira.nuxeo.com/browse/NXDRIVE-1772): Share Windows scripts to ease day-to-day development

## Minor Changes

- Packaging: Added `requests` 2.2.0
- Packaging: Removed `dataclasses` 0.6
- Packaging: Updated `markdown` from 3.1 to 3.1.1
- Packaging: Updated `nuxeo` from 2.0.5 to 2.2.1
- Packaging: Updated `psutil` from 5.6.2 to 5.6.3
- Packaging: Updated `pycryptodomex` from 3.8.1 to 3.8.2
- Packaging: Updated `sentry-sdk` from 0.7.3 to 0.10.2

## Technical Changes

- Added `AbstractOSIntegration.cb_get()` and implementations for all flavors
- Added `AbstractOSIntegration.cb_set()` and implementations for all flavors
- Removed `thread_id` keyword argument of `Action.__init__()`
- Renamed `Application.action_model` to `transfer_model`
- Renamed `Application.refresh_actions()` to `refresh_transfers()`
- Removed `Application.action_done()`
- Removed `Application.action_started()`
- Added `Application.refresh_files()`
- Added `BlackListItem.increase()`
- Added `BlackListItem.uid`
- Removed `BlackListItem.get()`. Use `name` attribute instead.
- Added `BlacklistQueue.repush()`
- Renamed `filename` keyword argument of `DownloadAction.__init__()` to `tmppath`
- Added `Download.filesize`
- Added `filesize` field to the `Downloads` SQL table
- Added `Engine.download_dir`
- Removed `Engine.get_dao()`. Use `dao` attribute instead.
- Removed `Engine.get_errors()`. Use `dao.get_errors()` instead.
- Removed `Engine.get_last_files()`. Use `dao.get_last_files()` instead.
- Removed `Engine.get_last_files_count()`. Use `dao.get_last_files_count()` instead.
- Removed `Engine.get_queue_manager()`. Use `queue_manager` attribute instead.
- Renamed `Engine.newSync` signal to `Engine.newSyncEnded`
- Added `Engine.newSyncStarted`
- Added `Engine.resume_suspended_transfers()`
- Added `Engine.resume_transfer()`
- Added `EngineDAO.get_download()`
- Added `EngineDAO.get_downloads()`
- Added `EngineDAO.get_downloads_with_status()`
- Added `EngineDAO.get_upload()`
- Added `EngineDAO.get_uploads()`
- Added `EngineDAO.get_uploads_with_status()`
- Added `EngineDAO.pause_transfer()`
- Added `EngineDAO.remove_transfer()`
- Added `EngineDAO.resume_transfer()`
- Added `EngineDAO.save_download()`
- Added `EngineDAO.save_upload()`
- Added `EngineDAO.set_transfer_doc()`
- Added `EngineDAO.set_transfer_progress()`
- Added `EngineDAO.set_transfer_status()`
- Added `EngineDAO.suspend_transfers()`
- Removed `state_factory` keyworkd argument from `EngineDAO.__init__()`
- Added `progress` argument to `EngineDAO.pause_transfer()`
- Changed `EngineDAO.update_remote_state()` return type from `None` to `bool`
- Added `ExtensionListener.address`
- Added `ExtensionListener.host_to_addr()`
- Renamed `filename` keyword argument of `FileAction.__init__()` to `tmppath`
- Added `FileModel.ID` role
- Added `FileModel.tr()`
- Added `LocalClient.set_path_remote_id()`
- Renamed `check_suspended` keyword argument of `LocalClient.__init__()` to `digest_callback`
- Changed `filename` argument type from `str` to `Path` for `LocalClient.is_temp_file()`
- Added `Manager.directEdit` signal
- Added `purge` argument to `Manager.unbind_engine()`
- Removed `Manager.get_dao()`. Use `dao` attribute instead.
- Removed `Manager.get_engines()`. Use `engines` attribute instead.
- Added `Options.big_file`
- Added `Options.tmp_file_limit`
- Renamed `Processor.pairSync` signal to `Processor.pairSyncEnded`
- Removed `Processor.tmp_file`
- Added `Processor.pairSyncStarted`
- Added `QMLDriveApi.get_transfers()`
- Added `QMLDriveApi.pause_transfer()`
- Added `QMLDriveApi.resume_transfer()`
- Added `purge` argument to `QMLDriveApi.unbind_server()`
- Added `Remote.check_integrity()`
- Added `digest` argument to `Remote.download()`
- Added `file_path` argument to `Remote.download()`
- Changed `file_out` keyword argument of `Remote.download()` to positional argument
- Changed `digest` keyword argument to to positional argument
- Added `Remote.link_blob_to_doc()`
- Added `Remote.upload_callback()`
- Added `Remote.upload_chunks()`
- Removed `Remote.upload_lock`
- Renamed `check_suspended` keyword argument of `Remote.__init__()` to `download_callback`
- Changed `file_out` keyword argument of `Remote.__init__()` to positional argument
- Added `TransferModel.PROGRESS_METRICS`
- Added `TransferModel.get_progress()`
- Added `TransferModel.tr()`
- Renamed `TransferModel.VERIFYING` to `FINALIZING`
- Renamed `filename` keyword argument of `UploadAction.__init__()` to `tmppath`
- Removed `filename` keyword argument from `VerificationAction.__init__()`
- Moved \_\_main__.py::`check_executable_path` to fatal_error.py
- Moved \_\_main__.py::`show_critical_error` to fatal_error.py
- Removed \_\_main__.py::`section`
- Added activity.py::`LinkingAction`
- Added constants.py::`LONG_FILE_ERRORS`
- Added constants.py::`TransferStatus`
- Removed constants.py::`DOWNLOAD_TMP_FILE_PREFIX`
- Removed constants.py::`DOWNLOAD_TMP_FILE_SUFFIX`
- Removed constants.py::`PARTIALS_PATH`
- Added engine/activity.py::`DownloadAction`
- Added engine/activity.py::`UploadAction`
- Added engine/activity.py::`VerificationAction`
- Added exceptions.py::`DownloadPaused`
- Added exceptions.py::`TransferPaused`
- Added exceptions.py::`UploadPaused`
- Removed exceptions.py::`Forbidden`. Use `nuxeo.exceptions.Forbidden` instead.
- Added fatal_error.py
- Renamed gui/view.py::`ActionModel` to `TransferModel`
- Added objects.py::`Download`
- Added objects.py::`Transfer`
- Added objects.py::`Upload`
- Added options.py::`validate_tmp_file_limit()`
- Added utils.py::`compute_digest()`
- Removed utils.py::`copy_to_clipboard()`
- Added utils.py::`current_thread_id()`
- Added utils.py::`find_suitable_tmp_dir()`
- Added utils.py::`safe_rename()`
- Added utils.py::`sizeof_fmt()`
